#!/usr/bin/env bash
set -ue

#####################################################################################################################
# Globals:
#   None
# Arguments:
#  project_path: location of the experiment folder (/esarchive/autosubmit/<expid>)
#  outclass: the outclass to be used for the generated outputs
# Returns:
#   None
# Purpose: Runs ec-config tool for EC-Earth3 for Marenostrum 5 architecture
#####################################################################################################################
function ecconfig() {

  local project_path=$1
  local outclass=$2
  local COMPILER_OPTION=$( echo "${COMPILERS}" | awk '{print tolower($0)}' )

  cd "${project_path}/sources/runtime/autosubmit"
  ln -sf ../classic/platform .
  #shellcheck disable=SC2086
  ../../sources/util/ec-conf/ec-conf --platform bsc-marenostrum5-${COMPILER_OPTION} \
    -o MOD:GENERAL:OUTPUT_CONTROL_FILES_DIR=${outclass} \
    ${ecearth_src_dir-} \
    config-run.xml

}
